package Entities 
{
	import flash.display.MovieClip;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author Chris Moeller
	 */
	
	public class Asteroid extends MovieClip 
	{
		public static const Directions:Array = [Math.PI / 4, 3 * Math.PI / 4, 5 * Math.PI / 4, 7 * Math.PI / 4];
		public static const Sizes:Array = [40, 20, 10];
		public static const Speeds:Array = [1, 3, 5];
		//PART 5: added for scores
		public static const Scores:Array = [20, 50, 100];
		
		public var size:int;
		public  var type:int;
		private var direction:Number;
		private var speed:Point;
		
		public function Asteroid(x:int, y:int, size:Number, direction:Number, type:int)
		{
			this.x = x;
			this.y = y;
			
			this.size = size;
			this.type = type;
			this.direction = direction = Directions[direction];
			this.speed = new Point( -Speeds[size] * Math.cos(direction), -Speeds[size] * Math.sin(direction));
			
			graphics.lineStyle(1, 0xFFFFFF);
			this.type = type;
			
			var ast_width:Number = Sizes[size];
			var ast_height:Number = Sizes[size];
			
			if (type == 0)
			{
				//first lets draw the asteroid
				//they are basically circles with some craggly looking edges
				graphics.moveTo(0, 1 / 3 * ast_height); 
				graphics.lineTo(1 / 3 * ast_width, 0);//top line
				graphics.lineTo(2 / 3 * ast_width, 0);//top line
				graphics.lineTo(ast_width, 1 / 3 * ast_height); //right slanted line
				graphics.lineTo(ast_width, 2 / 3 * ast_height); //right  line
				graphics.lineTo(2 / 3 * ast_width,  ast_height); //bottom right slanted line
				graphics.lineTo(ast_width / 2,  ast_height); //bottom line
				graphics.lineTo(ast_width / 2,  2 / 3 * ast_height); //vertical bottom line
				graphics.lineTo(1 / 3 * ast_width, ast_height); //slanted bottom left line
				graphics.lineTo(0, 2 / 3 * ast_height); //slanted bottom left line 2
				graphics.lineTo(1 / 3 * ast_width,  ast_height / 2); //slanted center left line 1
				graphics.lineTo(0, 1 / 3 * ast_height);//back to start
			}
			else
			{
				graphics.moveTo(0, 1 / 3 * ast_height);
				graphics.lineTo(1 / 3 * ast_width, 0);//to top left line
				graphics.lineTo(ast_width / 2, 1 / 3 * ast_height);//to center top
				graphics.lineTo(2 / 3 * ast_width, 0);//to top right line
				graphics.lineTo(ast_width, 1 / 3 * ast_height);//to right top line
				graphics.lineTo(4 / 5 * ast_width, ast_height / 2);//inward right center line
				graphics.lineTo( ast_width, 2 / 3 * ast_height);//to right bottom line
				graphics.lineTo( 2 / 3 * ast_width,  ast_height);//to bottom right line
				graphics.lineTo( 1 / 3 * ast_width,  ast_height);//to bottom left line
				graphics.lineTo( 0,  2 / 3 * ast_height);//to left bottom line
				graphics.lineTo(0, 1 / 3 * ast_height);//back tot he start
			}
			//super();
		}
		public function Update():void 
		{
			x += speed.x;
			y += speed.y;	
			
			if (x + width <= 0)
				x = Game.stageWidth - width;
			else if(x >= Game.stageWidth)
				x = 0;
				
			if (y + height <= 0)
				y = Game.stageHeight - height;
			else if(y >= Game.stageHeight)
				y = 0;				
		}
		
	}
}