package UI 
{
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	/**
	 * ...
	 * @author Chris Moeller
	 */
	public class TextButton extends UI_element 
	{
		public var bg_color2:uint;
		public var text:TextField;
		
		public var hovered:Boolean;
		public var clicked:Boolean;
		public var func:Function;
		
		public function TextButton(x:Number = 0, y:Number = 0, width:int = 10, height:int = 10, text_str:String="Button", format:TextFormat=null, background:Boolean = true, bg_color:uint = 0x333333, bg_color2:uint=0x666666, func:Function=null) 
		{

			super(x, y, width, height, background, bg_color);
			
			this.bg_color2 = bg_color2;
			
			text = new TextField();
			if (format == null)
			{
				format = new TextFormat("Arial", 20, 0x000000, true);
				format.align = "center";
			}
				
			text.width = width;
			text.height = height;
			text.defaultTextFormat = format;
			text.text = text_str;
			text.selectable = false;
			addChild(text);
			
			hovered = false;
			clicked = false;
			this.func = func;
			
			//to allow the hand pointer on buttons
			this.buttonMode = true;
			this.useHandCursor = true;
			this.mouseChildren = false;
		}
		override public function Update():void 
		{
			if (!visible)
				return;

			if (background)
			{
				graphics.clear();
				if(!hovered)
					graphics.beginFill(bg_color);
				else
					graphics.beginFill(bg_color2);
					
				graphics.drawRect(0, 0, width1, height1);
				graphics.endFill();
			}
			
			
			if (clicked)
			{
				trace("button Clicked!");
				if (func != null)
					func();
				clicked = false;
			}
			hovered = false;
		}
		
	}

}